]> git.ipfire.org Git - thirdparty/git.git/blame - git-rebase--interactive.sh
Merge branch 'nd/parseopt-completion-more'
[thirdparty/git.git] / git-rebase--interactive.sh
CommitLineData
11d62145
JN
1# This shell script fragment is sourced by git-rebase to implement
2# its interactive mode. "git rebase --interactive" makes it easy
3# to fix up commits in the middle of a series and rearrange commits.
1b1dce4b
JS
4#
5# Copyright (c) 2006 Johannes E. Schindelin
1b1dce4b
JS
6#
7# The original idea comes from Eric W. Biederman, in
5840eb9d 8# https://public-inbox.org/git/m1odwkyuf5.fsf_-_@ebiederm.dsl.xmission.com/
572a7c52 9#
80883bb3
MH
10# The file containing rebase commands, comments, and empty lines.
11# This file is created by "git rebase -i" then edited by the user. As
12# the lines are processed, they are removed from the front of this
6bb4e485 13# file and written to the tail of $done.
431b7e78 14todo="$state_dir"/git-rebase-todo
80883bb3
MH
15
16# The rebase command lines that have already been processed. A line
17# is moved here when it is first handled, before any associated user
18# actions.
431b7e78 19done="$state_dir"/done
80883bb3
MH
20
21# The commit message that is planned to be used for any changes that
22# need to be committed following a user interaction.
431b7e78 23msg="$state_dir"/message
80883bb3
MH
24
25# The file into which is accumulated the suggested commit message for
26# squash/fixup commands. When the first of a series of squash/fixups
27# is seen, the file is created and the commit message from the
28# previous commit and from the first squash/fixup commit are written
29# to it. The commit message for each subsequent squash/fixup commit
30# is appended to the file as it is processed.
31#
32# The first line of the file is of the form
6bb4e485
MZ
33# # This is a combination of $count commits.
34# where $count is the number of commits whose messages have been
80883bb3
MH
35# written to the file so far (including the initial "pick" commit).
36# Each time that a commit message is processed, this line is read and
37# updated. It is deleted just before the combined commit is made.
431b7e78 38squash_msg="$state_dir"/message-squash
80883bb3 39
a25eb139
MH
40# If the current series of squash/fixups has not yet included a squash
41# command, then this file exists and holds the commit message of the
42# original "pick" commit. (If the series ends without a "squash"
43# command, then this can be used as the commit message of the combined
44# commit without opening the editor.)
431b7e78 45fixup_msg="$state_dir"/message-fixup
a25eb139 46
6bb4e485
MZ
47# $rewritten is the name of a directory containing files for each
48# commit that is reachable by at least one merge base of $head and
49# $upstream. They are not necessarily rewritten, but their children
80883bb3
MH
50# might be. This ensures that commits on merged, but otherwise
51# unrelated side branches are left alone. (Think "X" in the man page's
52# example.)
431b7e78 53rewritten="$state_dir"/rewritten
80883bb3 54
431b7e78 55dropped="$state_dir"/dropped
0aac0de4 56
b71dc3e1
ZK
57end="$state_dir"/end
58msgnum="$state_dir"/msgnum
59
0aac0de4
MH
60# A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
61# GIT_AUTHOR_DATE that will be used for the commit that is currently
62# being rebased.
431b7e78 63author_script="$state_dir"/author-script
0aac0de4 64
a4049ae7
MH
65# When an "edit" rebase command is being processed, the SHA1 of the
66# commit to be edited is recorded in this file. When "git rebase
67# --continue" is executed, if there are any staged changes then they
68# will be amended to the HEAD commit, but only provided the HEAD
69# commit is still the commit to be edited. When any other rebase
70# command is processed, this file is deleted.
431b7e78 71amend="$state_dir"/amend
a4049ae7 72
b079feed
TR
73# For the post-rewrite hook, we make a list of rewritten commits and
74# their new sha1s. The rewritten-pending list keeps the sha1s of
75# commits that have been processed, but not committed yet,
76# e.g. because they are waiting for a 'squash' command.
431b7e78
MZ
77rewritten_list="$state_dir"/rewritten-list
78rewritten_pending="$state_dir"/rewritten-pending
6bb4e485 79
39743cf5
JH
80# Work around Git for Windows' Bash whose "read" does not strip CRLF
81# and leaves CR at the end instead.
82cr=$(printf "\015")
83
040fd39e 84strategy_args=${strategy:+--strategy=$strategy}
8e98b35f 85test -n "$strategy_opts" &&
040fd39e
FR
86eval '
87 for strategy_opt in '"$strategy_opts"'
88 do
89 strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
90 done
91'
db2b3b82 92
89c7ae9c 93GIT_CHERRY_PICK_HELP="$resolvemsg"
804c7174
WC
94export GIT_CHERRY_PICK_HELP
95
882cd237
JS
96comment_char=$(git config --get core.commentchar 2>/dev/null)
97case "$comment_char" in
98'' | auto)
99 comment_char="#"
100 ;;
101?)
102 ;;
103*)
104 comment_char=$(echo "$comment_char" | cut -c1)
105 ;;
106esac
180bad3d 107
1b1dce4b 108warn () {
938791cd 109 printf '%s\n' "$*" >&2
1b1dce4b
JS
110}
111
ee0a4afb
MH
112# Output the commit message for the specified commit.
113commit_message () {
114 git cat-file commit "$1" | sed "1,/^$/d"
115}
116
6bb4e485 117orig_reflog_action="$GIT_REFLOG_ACTION"
1b1dce4b
JS
118
119comment_for_reflog () {
6bb4e485 120 case "$orig_reflog_action" in
1b1dce4b
JS
121 ''|rebase*)
122 GIT_REFLOG_ACTION="rebase -i ($1)"
123 export GIT_REFLOG_ACTION
376ccb8c 124 ;;
1b1dce4b
JS
125 esac
126}
127
4e673877 128last_count=
1b1dce4b 129mark_action_done () {
6bb4e485
MZ
130 sed -e 1q < "$todo" >> "$done"
131 sed -e 1d < "$todo" >> "$todo".new
132 mv -f "$todo".new "$todo"
d9497518 133 new_count=$(( $(git stripspace --strip-comments <"$done" | wc -l) ))
b71dc3e1 134 echo $new_count >"$msgnum"
180bad3d 135 total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
b71dc3e1 136 echo $total >"$end"
6bb4e485 137 if test "$last_count" != "$new_count"
4e673877 138 then
6bb4e485 139 last_count=$new_count
9588c52b 140 eval_gettext "Rebasing (\$new_count/\$total)"; printf "\r"
6bb4e485 141 test -z "$verbose" || echo
4e673877 142 fi
1b1dce4b
JS
143}
144
8cbc57ca
PH
145# Put the last action marked done at the beginning of the todo list
146# again. If there has not been an action marked done yet, leave the list of
147# items on the todo list unchanged.
148reschedule_last_action () {
149 tail -n 1 "$done" | cat - "$todo" >"$todo".new
150 sed -e \$d <"$done" >"$done".new
151 mv -f "$todo".new "$todo"
152 mv -f "$done".new "$done"
153}
154
fcc5ef1c 155append_todo_help () {
b8fc9e43 156 gettext "
180bad3d 157Commands:
4b8b65d7
JS
158p, pick = use commit
159r, reword = use commit, but edit the commit message
160e, edit = use commit, but stop for amending
161s, squash = use commit, but meld into previous commit
162f, fixup = like \"squash\", but discard this commit's log message
163x, exec = run command (the rest of the line) using shell
164d, drop = remove commit
180bad3d
JK
165
166These lines can be re-ordered; they are executed from top to bottom.
b8fc9e43 167" | git stripspace --comment-lines >>"$todo"
180bad3d 168
37079959
GR
169 if test $(get_missing_commit_check_level) = error
170 then
b8fc9e43 171 gettext "
37079959 172Do not remove any line. Use 'drop' explicitly to remove a commit.
b8fc9e43 173" | git stripspace --comment-lines >>"$todo"
37079959 174 else
b8fc9e43 175 gettext "
180bad3d 176If you remove a line here THAT COMMIT WILL BE LOST.
b8fc9e43 177" | git stripspace --comment-lines >>"$todo"
37079959 178 fi
fcc5ef1c
AW
179}
180
1b1dce4b 181make_patch () {
4fb1a19d
JS
182 sha1_and_parents="$(git rev-list --parents -1 "$1")"
183 case "$sha1_and_parents" in
184 ?*' '?*' '?*)
185 git diff --cc $sha1_and_parents
186 ;;
187 ?*' '?*)
188 git diff-tree -p "$1^!"
189 ;;
190 *)
191 echo "Root commit"
192 ;;
431b7e78 193 esac > "$state_dir"/patch
6bb4e485
MZ
194 test -f "$msg" ||
195 commit_message "$1" > "$msg"
196 test -f "$author_script" ||
197 get_author_ident_from_commit "$1" > "$author_script"
1b1dce4b
JS
198}
199
200die_with_patch () {
431b7e78 201 echo "$1" > "$state_dir"/stopped-sha
fbd7a232 202 git update-ref REBASE_HEAD "$1"
1b1dce4b
JS
203 make_patch "$1"
204 die "$2"
205}
206
0becb3e4
AW
207exit_with_patch () {
208 echo "$1" > "$state_dir"/stopped-sha
fbd7a232 209 git update-ref REBASE_HEAD "$1"
0becb3e4
AW
210 make_patch $1
211 git rev-parse --verify HEAD > "$amend"
3ee5e540 212 gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
9588c52b
VA
213 warn "$(eval_gettext "\
214You can amend the commit now, with
215
216 git commit --amend \$gpg_sign_opt_quoted
217
218Once you are satisfied with your changes, run
219
220 git rebase --continue")"
0becb3e4
AW
221 warn
222 exit $2
223}
224
c54b7817 225die_abort () {
33ba9c64 226 apply_autostash
431b7e78 227 rm -rf "$state_dir"
c54b7817
JS
228 die "$1"
229}
230
376ccb8c 231has_action () {
180bad3d 232 test -n "$(git stripspace --strip-comments <"$1")"
376ccb8c
JS
233}
234
90e1818f 235is_empty_commit() {
9588c52b
VA
236 tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null) || {
237 sha1=$1
238 die "$(eval_gettext "\$sha1: not a commit that can be picked")"
239 }
240 ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null) ||
241 ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
90e1818f
NH
242 test "$tree" = "$ptree"
243}
244
98697784
PH
245is_merge_commit()
246{
247 git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
248}
249
7756ecff
MH
250# Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
251# GIT_AUTHOR_DATE exported from the current environment.
252do_with_author () {
76c9c0db
JH
253 (
254 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
255 "$@"
256 )
7756ecff
MH
257}
258
821881d8
PO
259git_sequence_editor () {
260 if test -z "$GIT_SEQUENCE_EDITOR"
261 then
262 GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
263 if [ -z "$GIT_SEQUENCE_EDITOR" ]
264 then
265 GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
266 fi
267 fi
268
269 eval "$GIT_SEQUENCE_EDITOR" '"$@"'
270}
271
1b1dce4b 272pick_one () {
8e75abfd 273 ff=--ff
90e1818f 274
8e75abfd 275 case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
6bb4e485 276 case "$force_rebase" in '') ;; ?*) ff= ;; esac
9588c52b 277 output git rev-parse --verify $sha1 || die "$(eval_gettext "Invalid commit name: \$sha1")"
90e1818f
NH
278
279 if is_empty_commit "$sha1"
280 then
281 empty_args="--allow-empty"
282 fi
283
6bb4e485 284 test -d "$rewritten" &&
f09c9b8c 285 pick_one_preserving_merges "$@" && return
a6c612b5 286 output eval git cherry-pick $allow_rerere_autoupdate $allow_empty_message \
3ee5e540
NV
287 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
288 "$strategy_args" $empty_args $ff "$@"
8cbc57ca
PH
289
290 # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
291 # previous task so this commit is not lost.
292 ret=$?
293 case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
294 return $ret
1b1dce4b
JS
295}
296
f09c9b8c 297pick_one_preserving_merges () {
71d9451e
TR
298 fast_forward=t
299 case "$1" in
300 -n)
301 fast_forward=f
302 sha1=$2
303 ;;
304 *)
305 sha1=$1
306 ;;
307 esac
f09c9b8c
JS
308 sha1=$(git rev-parse $sha1)
309
0c4030ca 310 if test -f "$state_dir"/current-commit && test "$fast_forward" = t
f09c9b8c 311 then
0c4030ca
WS
312 while read current_commit
313 do
314 git rev-parse HEAD > "$rewritten"/$current_commit
315 done <"$state_dir"/current-commit
316 rm "$state_dir"/current-commit ||
317 die "$(gettext "Cannot write current commit's replacement sha1")"
f09c9b8c
JS
318 fi
319
431b7e78 320 echo $sha1 >> "$state_dir"/current-commit
a96dc01e 321
f09c9b8c 322 # rewrite parents; if none were rewritten, we can fast-forward.
f09c9b8c 323 new_parents=
d911d146
TR
324 pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
325 if test "$pend" = " "
326 then
327 pend=" root"
328 fi
faae853c 329 while [ "$pend" != "" ]
f09c9b8c 330 do
faae853c
SH
331 p=$(expr "$pend" : ' \([^ ]*\)')
332 pend="${pend# $p}"
333
6bb4e485 334 if test -f "$rewritten"/$p
f09c9b8c 335 then
6bb4e485 336 new_p=$(cat "$rewritten"/$p)
80fe82e4
SH
337
338 # If the todo reordered commits, and our parent is marked for
339 # rewriting, but hasn't been gotten to yet, assume the user meant to
340 # drop it on top of the current HEAD
341 if test -z "$new_p"
342 then
343 new_p=$(git rev-parse HEAD)
344 fi
345
f09c9b8c
JS
346 test $p != $new_p && fast_forward=f
347 case "$new_parents" in
348 *$new_p*)
349 ;; # do nothing; that parent is already there
350 *)
351 new_parents="$new_parents $new_p"
376ccb8c 352 ;;
f09c9b8c 353 esac
1c5fa0a1 354 else
6bb4e485 355 if test -f "$dropped"/$p
faae853c
SH
356 then
357 fast_forward=f
6bb4e485 358 replacement="$(cat "$dropped"/$p)"
d911d146
TR
359 test -z "$replacement" && replacement=root
360 pend=" $replacement$pend"
faae853c
SH
361 else
362 new_parents="$new_parents $p"
363 fi
f09c9b8c
JS
364 fi
365 done
366 case $fast_forward in
367 t)
9588c52b 368 output warn "$(eval_gettext "Fast-forward to \$sha1")"
71d9451e 369 output git reset --hard $sha1 ||
9588c52b 370 die "$(eval_gettext "Cannot fast-forward to \$sha1")"
f09c9b8c
JS
371 ;;
372 f)
376ccb8c 373 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
a4f25e36
SH
374
375 if [ "$1" != "-n" ]
376 then
377 # detach HEAD to current parent
378 output git checkout $first_parent 2> /dev/null ||
9588c52b 379 die "$(eval_gettext "Cannot move HEAD to \$first_parent")"
a4f25e36 380 fi
f09c9b8c 381
f09c9b8c 382 case "$new_parents" in
376ccb8c 383 ' '*' '*)
9588c52b 384 test "a$1" = a-n && die "$(eval_gettext "Refusing to squash a merge: \$sha1")"
a4f25e36 385
f09c9b8c 386 # redo merge
6bb4e485
MZ
387 author_script_content=$(get_author_ident_from_commit $sha1)
388 eval "$author_script_content"
389 msg_content="$(commit_message $sha1)"
f91333d6
BS
390 # No point in merging the first parent, that's HEAD
391 new_parents=${new_parents# $first_parent}
a9f739c1 392 merge_args="--no-log --no-ff"
db2b3b82 393 if ! do_with_author output eval \
dd6fb005
JS
394 git merge ${gpg_sign_opt:+$(git rev-parse \
395 --sq-quote "$gpg_sign_opt")} \
396 $allow_rerere_autoupdate "$merge_args" \
397 "$strategy_args" \
ed5144d7 398 -m "$(git rev-parse --sq-quote "$msg_content")" \
dd6fb005 399 "$new_parents"
f09c9b8c 400 then
6bb4e485 401 printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
9588c52b 402 die_with_patch $sha1 "$(eval_gettext "Error redoing merge \$sha1")"
f09c9b8c 403 fi
6bb4e485 404 echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
f09c9b8c
JS
405 ;;
406 *)
9b6d7a62 407 output eval git cherry-pick $allow_rerere_autoupdate \
a6c612b5 408 $allow_empty_message \
3ee5e540
NV
409 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
410 "$strategy_args" "$@" ||
9588c52b 411 die_with_patch $sha1 "$(eval_gettext "Could not pick \$sha1")"
376ccb8c 412 ;;
f09c9b8c 413 esac
376ccb8c 414 ;;
f09c9b8c
JS
415 esac
416}
417
f2d17068
VA
418this_nth_commit_message () {
419 n=$1
8aa6dc1d 420 eval_gettext "This is the commit message #\${n}:"
f2d17068 421}
8aa6dc1d 422
f2d17068
VA
423skip_nth_commit_message () {
424 n=$1
8aa6dc1d 425 eval_gettext "The commit message #\${n} will be skipped:"
6368f3f8
JS
426}
427
a25eb139 428update_squash_messages () {
6bb4e485
MZ
429 if test -f "$squash_msg"; then
430 mv "$squash_msg" "$squash_msg".bak || exit
431 count=$(($(sed -n \
356b8ecf 432 -e "1s/^$comment_char[^0-9]*\([0-9][0-9]*\).*/\1/p" \
6bb4e485 433 -e "q" < "$squash_msg".bak)+1))
bde1a686 434 {
f2d17068
VA
435 printf '%s\n' "$comment_char $(eval_ngettext \
436 "This is a combination of \$count commit." \
437 "This is a combination of \$count commits." \
438 $count)"
bde1a686
MH
439 sed -e 1d -e '2,/^./{
440 /^$/d
6bb4e485
MZ
441 }' <"$squash_msg".bak
442 } >"$squash_msg"
6368f3f8 443 else
acefe2be
JH
444 commit_message HEAD >"$fixup_msg" ||
445 die "$(eval_gettext "Cannot write \$fixup_msg")"
6bb4e485 446 count=2
bde1a686 447 {
f2d17068
VA
448 printf '%s\n' "$comment_char $(gettext "This is a combination of 2 commits.")"
449 printf '%s\n' "$comment_char $(gettext "This is the 1st commit message:")"
bde1a686 450 echo
6bb4e485
MZ
451 cat "$fixup_msg"
452 } >"$squash_msg"
6368f3f8 453 fi
0205e72f
MH
454 case $1 in
455 squash)
6bb4e485 456 rm -f "$fixup_msg"
0205e72f 457 echo
f2d17068 458 printf '%s\n' "$comment_char $(this_nth_commit_message $count)"
0205e72f 459 echo
ee0a4afb 460 commit_message $2
0205e72f
MH
461 ;;
462 fixup)
463 echo
f2d17068 464 printf '%s\n' "$comment_char $(skip_nth_commit_message $count)"
0205e72f 465 echo
180bad3d
JK
466 # Change the space after the comment character to TAB:
467 commit_message $2 | git stripspace --comment-lines | sed -e 's/ / /'
0205e72f 468 ;;
6bb4e485 469 esac >>"$squash_msg"
6368f3f8
JS
470}
471
472peek_next_command () {
180bad3d 473 git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
6368f3f8
JS
474}
475
6bdcd0d2
MH
476# A squash/fixup has failed. Prepare the long version of the squash
477# commit message, then die_with_patch. This code path requires the
478# user to edit the combined commit message for all commits that have
479# been squashed/fixedup so far. So also erase the old squash
480# messages, effectively causing the combined commit to be used as the
481# new basis for any further squash/fixups. Args: sha1 rest
482die_failed_squash() {
9588c52b
VA
483 sha1=$1
484 rest=$2
6bb4e485
MZ
485 mv "$squash_msg" "$msg" || exit
486 rm -f "$fixup_msg"
487 cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
6bdcd0d2 488 warn
9588c52b
VA
489 warn "$(eval_gettext "Could not apply \$sha1... \$rest")"
490 die_with_patch $sha1 ""
6bdcd0d2
MH
491}
492
b079feed 493flush_rewritten_pending() {
6bb4e485 494 test -s "$rewritten_pending" || return
b079feed 495 newsha1="$(git rev-parse HEAD^0)"
6bb4e485
MZ
496 sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
497 rm -f "$rewritten_pending"
b079feed
TR
498}
499
500record_in_rewritten() {
501 oldsha1="$(git rev-parse $1)"
6bb4e485 502 echo "$oldsha1" >> "$rewritten_pending"
b079feed
TR
503
504 case "$(peek_next_command)" in
41f556b9 505 squash|s|fixup|f)
b079feed 506 ;;
41f556b9 507 *)
b079feed
TR
508 flush_rewritten_pending
509 ;;
510 esac
511}
512
df5df20c 513do_pick () {
9588c52b
VA
514 sha1=$1
515 rest=$2
df5df20c
CW
516 if test "$(git rev-parse HEAD)" = "$squash_onto"
517 then
518 # Set the correct commit message and author info on the
519 # sentinel root before cherry-picking the original changes
520 # without committing (-n). Finally, update the sentinel again
521 # to include these changes. If the cherry-pick results in a
522 # conflict, this means our behaviour is similar to a standard
523 # failed cherry-pick during rebase, with a dirty index to
524 # resolve before manually running git commit --amend then git
525 # rebase --continue.
526 git commit --allow-empty --allow-empty-message --amend \
9588c52b
VA
527 --no-post-rewrite -n -q -C $sha1 &&
528 pick_one -n $sha1 &&
df5df20c 529 git commit --allow-empty --allow-empty-message \
9588c52b 530 --amend --no-post-rewrite -n -q -C $sha1 \
3ee5e540 531 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
9588c52b 532 die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
df5df20c 533 else
9588c52b
VA
534 pick_one $sha1 ||
535 die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
df5df20c
CW
536 fi
537}
538
1b1dce4b 539do_next () {
b12d3e90 540 rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
6bb4e485 541 read -r command sha1 rest < "$todo"
1b1dce4b 542 case "$command" in
c9266d58 543 "$comment_char"*|''|noop|drop|d)
1b1dce4b 544 mark_action_done
1b1dce4b 545 ;;
39743cf5
JH
546 "$cr")
547 # Work around CR left by "read" (e.g. with Git for Windows' Bash).
548 mark_action_done
549 ;;
f8babc4d 550 pick|p)
1b1dce4b
JS
551 comment_for_reflog pick
552
553 mark_action_done
df5df20c 554 do_pick $sha1 "$rest"
b079feed 555 record_in_rewritten $sha1
1b1dce4b 556 ;;
6741aa6c
BG
557 reword|r)
558 comment_for_reflog reword
559
560 mark_action_done
df5df20c 561 do_pick $sha1 "$rest"
a6c612b5
GS
562 git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} \
563 $allow_empty_message || {
9588c52b
VA
564 warn "$(eval_gettext "\
565Could not amend commit after successfully picking \$sha1... \$rest
566This is most likely due to an empty commit message, or the pre-commit hook
567failed. If the pre-commit hook failed, you may need to resolve the issue before
568you are able to reword the commit.")"
0becb3e4
AW
569 exit_with_patch $sha1 1
570 }
b079feed 571 record_in_rewritten $sha1
6741aa6c 572 ;;
f8babc4d 573 edit|e)
1b1dce4b
JS
574 comment_for_reflog edit
575
576 mark_action_done
df5df20c 577 do_pick $sha1 "$rest"
14c793e8 578 sha1_abbrev=$(git rev-parse --short $sha1)
9588c52b 579 warn "$(eval_gettext "Stopped at \$sha1_abbrev... \$rest")"
0becb3e4 580 exit_with_patch $sha1 0
1b1dce4b 581 ;;
0205e72f
MH
582 squash|s|fixup|f)
583 case "$command" in
584 squash|s)
585 squash_style=squash
586 ;;
587 fixup|f)
588 squash_style=fixup
589 ;;
590 esac
591 comment_for_reflog $squash_style
1b1dce4b 592
6bb4e485 593 test -f "$done" && has_action "$done" ||
9588c52b 594 die "$(eval_gettext "Cannot '\$squash_style' without a previous commit")"
1b1dce4b
JS
595
596 mark_action_done
a25eb139 597 update_squash_messages $squash_style $sha1
6bb4e485
MZ
598 author_script_content=$(get_author_ident_from_commit HEAD)
599 echo "$author_script_content" > "$author_script"
600 eval "$author_script_content"
2147f844
CW
601 if ! pick_one -n $sha1
602 then
603 git rev-parse --verify HEAD >"$amend"
604 die_failed_squash $sha1 "$rest"
605 fi
6368f3f8 606 case "$(peek_next_command)" in
0205e72f 607 squash|s|fixup|f)
a25eb139
MH
608 # This is an intermediate commit; its message will only be
609 # used in case of trouble. So use the long version:
3ee5e540 610 do_with_author output git commit --amend --no-verify -F "$squash_msg" \
a6c612b5 611 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
6bdcd0d2 612 die_failed_squash $sha1 "$rest"
376ccb8c 613 ;;
6368f3f8 614 *)
a25eb139 615 # This is the final command of this squash/fixup group
6bb4e485 616 if test -f "$fixup_msg"
a25eb139 617 then
3ee5e540 618 do_with_author git commit --amend --no-verify -F "$fixup_msg" \
a6c612b5 619 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
6bdcd0d2
MH
620 die_failed_squash $sha1 "$rest"
621 else
6bb4e485 622 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
6bdcd0d2 623 rm -f "$GIT_DIR"/MERGE_MSG
3ee5e540 624 do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
a6c612b5 625 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
6bdcd0d2 626 die_failed_squash $sha1 "$rest"
a25eb139 627 fi
6bb4e485 628 rm -f "$squash_msg" "$fixup_msg"
376ccb8c 629 ;;
6368f3f8 630 esac
b079feed 631 record_in_rewritten $sha1
1b1dce4b 632 ;;
cd035b1c 633 x|"exec")
6bb4e485 634 read -r command rest < "$todo"
cd035b1c 635 mark_action_done
9588c52b 636 eval_gettextln "Executing: \$rest"
fe9394ad 637 "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
cd035b1c 638 status=$?
1686519a
JH
639 # Run in subshell because require_clean_work_tree can die.
640 dirty=f
641 (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
cd035b1c
MM
642 if test "$status" -ne 0
643 then
9588c52b 644 warn "$(eval_gettext "Execution failed: \$rest")"
1686519a 645 test "$dirty" = f ||
9588c52b 646 warn "$(gettext "and made changes to the index and/or the working tree")"
1686519a 647
9588c52b
VA
648 warn "$(gettext "\
649You can fix the problem, and then run
650
651 git rebase --continue")"
cd035b1c 652 warn
ecfe1ea9
JS
653 if test $status -eq 127 # command not found
654 then
655 status=1
656 fi
cd035b1c 657 exit "$status"
1686519a 658 elif test "$dirty" = t
cd035b1c 659 then
9588c52b
VA
660 # TRANSLATORS: after these lines is a command to be issued by the user
661 warn "$(eval_gettext "\
662Execution succeeded: \$rest
663but left changes to the index and/or the working tree
664Commit or stash your changes, and then run
665
666 git rebase --continue")"
cd035b1c
MM
667 warn
668 exit 1
669 fi
670 ;;
1b1dce4b 671 *)
9588c52b
VA
672 warn "$(eval_gettext "Unknown command: \$command \$sha1 \$rest")"
673 fixtodo="$(gettext "Please fix this using 'git rebase --edit-todo'.")"
f1be316a
JK
674 if git rev-parse --verify -q "$sha1" >/dev/null
675 then
9c8e1011 676 die_with_patch $sha1 "$fixtodo"
f1be316a 677 else
9c8e1011 678 die "$fixtodo"
f1be316a 679 fi
376ccb8c 680 ;;
1b1dce4b 681 esac
6bb4e485 682 test -s "$todo" && return
1b1dce4b 683
68a163c9 684 comment_for_reflog finish &&
6bb4e485 685 newhead=$(git rev-parse HEAD) &&
431b7e78 686 case $head_name in
73697a0b 687 refs/*)
1af221ef 688 message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
431b7e78 689 git update-ref -m "$message" $head_name $newhead $orig_head &&
53f2ffa8
JK
690 git symbolic-ref \
691 -m "$GIT_REFLOG_ACTION: returning to $head_name" \
692 HEAD $head_name
73697a0b
JS
693 ;;
694 esac && {
431b7e78 695 test ! -f "$state_dir"/verbose ||
2959c283 696 git diff-tree --stat $orig_head..HEAD
3df0a859 697 } &&
eb2151bb 698 {
6bb4e485
MZ
699 test -s "$rewritten_list" &&
700 git notes copy --for-rewrite=rebase < "$rewritten_list" ||
eb2151bb
TR
701 true # we don't care if this copying failed
702 } &&
b849b954
NTND
703 hook="$(git rev-parse --git-path hooks/post-rewrite)"
704 if test -x "$hook" && test -s "$rewritten_list"; then
705 "$hook" rebase < "$rewritten_list"
b079feed
TR
706 true # we don't care if this hook failed
707 fi &&
9588c52b 708 warn "$(eval_gettext "Successfully rebased and updated \$head_name.")"
1b1dce4b 709
15d4bf2e 710 return 1 # not failure; just to break the do_rest loop
1b1dce4b
JS
711}
712
15d4bf2e 713# can only return 0, when the infinite loop breaks
1b1dce4b
JS
714do_rest () {
715 while :
716 do
15d4bf2e 717 do_next || break
1b1dce4b 718 done
1b1dce4b
JS
719}
720
75c69766 721expand_todo_ids() {
3546c8d9 722 git rebase--helper --expand-ids
75c69766
JH
723}
724
725collapse_todo_ids() {
3546c8d9 726 git rebase--helper --shorten-ids
f59baa50
NS
727}
728
37079959
GR
729# Switch to the branch in $into and notify it in the reflog
730checkout_onto () {
731 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
9588c52b 732 output git checkout $onto || die_abort "$(gettext "could not detach HEAD")"
37079959
GR
733 git update-ref ORIG_HEAD $orig_head
734}
735
736get_missing_commit_check_level () {
737 check_level=$(git config --get rebase.missingCommitsCheck)
738 check_level=${check_level:-ignore}
739 # Don't be case sensitive
740 printf '%s' "$check_level" | tr 'A-Z' 'a-z'
741}
742
27c499bf
WS
743# Initiate an action. If the cannot be any
744# further action it may exec a command
745# or exit and not return.
746#
747# TODO: Consider a cleaner return model so it
748# never exits and always return 0 if process
749# is complete.
750#
751# Parameter 1 is the action to initiate.
752#
753# Returns 0 if the action was able to complete
754# and if 1 if further processing is required.
755initiate_action () {
756 case "$1" in
d48f97aa
WS
757 continue)
758 if test ! -d "$rewritten"
ffaaed88 759 then
d48f97aa
WS
760 exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
761 --continue
762 fi
763 # do we have anything to commit?
764 if git diff-index --cached --quiet HEAD --
765 then
766 # Nothing to commit -- skip this commit
767
768 test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
769 rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
770 die "$(gettext "Could not remove CHERRY_PICK_HEAD")"
771 else
772 if ! test -f "$author_script"
773 then
774 gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
775 die "$(eval_gettext "\
9588c52b
VA
776You have staged changes in your working tree.
777If these changes are meant to be
ffaaed88
MM
778squashed into the previous commit, run:
779
9588c52b 780 git commit --amend \$gpg_sign_opt_quoted
ffaaed88
MM
781
782If they are meant to go into a new commit, run:
783
9588c52b 784 git commit \$gpg_sign_opt_quoted
ffaaed88 785
7c406bd8 786In both cases, once you're done, continue with:
ffaaed88
MM
787
788 git rebase --continue
9588c52b 789")"
d48f97aa
WS
790 fi
791 . "$author_script" ||
792 die "$(gettext "Error trying to find the author identity to amend commit")"
793 if test -f "$amend"
794 then
795 current_head=$(git rev-parse --verify HEAD)
796 test "$current_head" = $(cat "$amend") ||
797 die "$(gettext "\
9588c52b
VA
798You have uncommitted changes in your working tree. Please commit them
799first and then run 'git rebase --continue' again.")"
d48f97aa
WS
800 do_with_author git commit --amend --no-verify -F "$msg" -e \
801 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
802 die "$(gettext "Could not commit staged changes.")"
803 else
804 do_with_author git commit --no-verify -F "$msg" -e \
805 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
806 die "$(gettext "Could not commit staged changes.")"
807 fi
03270628 808 fi
18640d99 809
d48f97aa
WS
810 if test -r "$state_dir"/stopped-sha
811 then
812 record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
813 fi
0acb62f2 814
d48f97aa
WS
815 require_clean_work_tree "rebase"
816 do_rest
817 return 0
818 ;;
819 skip)
820 git rerere clear
cf432ca0 821
d48f97aa
WS
822 if test ! -d "$rewritten"
823 then
824 exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
825 --continue
826 fi
827 do_rest
828 return 0
829 ;;
830 edit-todo)
831 git stripspace --strip-comments <"$todo" >"$todo".new
832 mv -f "$todo".new "$todo"
833 collapse_todo_ids
834 append_todo_help
835 gettext "
180bad3d
JK
836You are editing the todo file of an ongoing interactive rebase.
837To continue rebase after editing, run:
838 git rebase --continue
839
b8fc9e43 840" | git stripspace --comment-lines >>"$todo"
eb9a7cb4 841
d48f97aa
WS
842 git_sequence_editor "$todo" ||
843 die "$(gettext "Could not execute editor")"
844 expand_todo_ids
34262322 845
d48f97aa
WS
846 exit
847 ;;
848 show-current-patch)
849 exec git show REBASE_HEAD --
850 ;;
27c499bf
WS
851 *)
852 return 1 # continue
853 ;;
d48f97aa 854 esac
27c499bf 855}
26cd160c 856
27c499bf 857setup_reflog_action () {
26cd160c 858 comment_for_reflog start
34262322 859
d48f97aa 860 if test ! -z "$switch_to"
34262322 861 then
d48f97aa
WS
862 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
863 output git checkout "$switch_to" -- ||
864 die "$(eval_gettext "Could not checkout \$switch_to")"
865
866 comment_for_reflog start
34262322 867 fi
27c499bf 868}
62db5247 869
27c499bf 870init_basic_state () {
d48f97aa
WS
871 orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
872 mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
873 rm -f "$(git rev-parse --git-path REBASE_HEAD)"
90e1818f 874
d48f97aa
WS
875 : > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
876 write_basic_state
27c499bf
WS
877}
878
879init_revisions_and_shortrevisions () {
880 shorthead=$(git rev-parse --short $orig_head)
881 shortonto=$(git rev-parse --short $onto)
882 if test -z "$rebase_root"
883 # this is now equivalent to ! -z "$upstream"
884 then
885 shortupstream=$(git rev-parse --short $upstream)
886 revisions=$upstream...$orig_head
887 shortrevisions=$shortupstream..$shorthead
888 else
889 revisions=$onto...$orig_head
890 shortrevisions=$shorthead
891 fi
892}
893
894complete_action() {
895 test -s "$todo" || echo noop >> "$todo"
896 test -z "$autosquash" || git rebase--helper --rearrange-squash || exit
897 test -n "$cmd" && git rebase--helper --add-exec-commands "$cmd"
898
899 todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
900 todocount=${todocount##* }
901
902cat >>"$todo" <<EOF
903
904$comment_char $(eval_ngettext \
905 "Rebase \$shortrevisions onto \$shortonto (\$todocount command)" \
906 "Rebase \$shortrevisions onto \$shortonto (\$todocount commands)" \
907 "$todocount")
908EOF
909 append_todo_help
910 gettext "
911 However, if you remove everything, the rebase will be aborted.
912
913 " | git stripspace --comment-lines >>"$todo"
914
915 if test -z "$keep_empty"
916 then
917 printf '%s\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
918 fi
919
920
921 has_action "$todo" ||
922 return 2
923
924 cp "$todo" "$todo".backup
925 collapse_todo_ids
926 git_sequence_editor "$todo" ||
927 die_abort "$(gettext "Could not execute editor")"
928
929 has_action "$todo" ||
930 return 2
931
932 git rebase--helper --check-todo-list || {
933 ret=$?
934 checkout_onto
935 exit $ret
936 }
937
938 expand_todo_ids
939
940 test -d "$rewritten" || test -n "$force_rebase" ||
941 onto="$(git rebase--helper --skip-unnecessary-picks)" ||
942 die "Could not skip unnecessary pick commands"
943
944 checkout_onto
945 if test -z "$rebase_root" && test ! -d "$rewritten"
946 then
947 require_clean_work_tree "rebase"
948 exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
949 --continue
950 fi
951 do_rest
952}
953
954git_rebase__interactive () {
955 initiate_action "$action"
956 ret=$?
957 if test $ret = 0; then
958 return 0
959 fi
960
961 setup_reflog_action
962 init_basic_state
963
27c499bf
WS
964 init_revisions_and_shortrevisions
965
c04549b2
WS
966 git rebase--helper --make-script ${keep_empty:+--keep-empty} \
967 $revisions ${restrict_revision+^$restrict_revision} >"$todo" ||
968 die "$(gettext "Could not generate todo list")"
950b487c
WS
969
970 complete_action
971}
972
973git_rebase__interactive__preserve_merges () {
974 initiate_action "$action"
975 ret=$?
976 if test $ret = 0; then
977 return 0
978 fi
979
980 setup_reflog_action
981 init_basic_state
982
ca3d446e 983 if test -z "$rebase_root"
950b487c 984 then
ca3d446e
WS
985 mkdir "$rewritten" &&
986 for c in $(git merge-base --all $orig_head $upstream)
987 do
988 echo $onto > "$rewritten"/$c ||
950b487c 989 die "$(gettext "Could not init rewritten commits")"
ca3d446e 990 done
950b487c 991 else
ca3d446e
WS
992 mkdir "$rewritten" &&
993 echo $onto > "$rewritten"/root ||
994 die "$(gettext "Could not init rewritten commits")"
950b487c
WS
995 fi
996
997 init_revisions_and_shortrevisions
998
ca3d446e
WS
999 format=$(git config --get rebase.instructionFormat)
1000 # the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
f24cd418 1001 git rev-list --format="%m%H ${format:-%s}" \
ca3d446e
WS
1002 --reverse --left-right --topo-order \
1003 $revisions ${restrict_revision+^$restrict_revision} | \
1004 sed -n "s/^>//p" |
1005 while read -r sha1 rest
1006 do
ca3d446e
WS
1007 if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
1008 then
1009 comment_out="$comment_char "
1010 else
1011 comment_out=
1012 fi
d48f97aa 1013
ca3d446e
WS
1014 if test -z "$rebase_root"
1015 then
1016 preserve=t
1017 for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
1018 do
1019 if test -f "$rewritten"/$p
1020 then
1021 preserve=f
1022 fi
1023 done
1024 else
1025 preserve=f
1026 fi
1027 if test f = "$preserve"
1028 then
1029 touch "$rewritten"/$sha1
1030 printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1031 fi
1032 done
d48f97aa
WS
1033
1034 # Watch for commits that been dropped by --cherry-pick
ca3d446e
WS
1035 mkdir "$dropped"
1036 # Save all non-cherry-picked changes
1037 git rev-list $revisions --left-right --cherry-pick | \
1038 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
1039 # Now all commits and note which ones are missing in
1040 # not-cherry-picks and hence being dropped
1041 git rev-list $revisions |
1042 while read rev
1043 do
1044 if test -f "$rewritten"/$rev &&
1045 ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
1046 then
1047 # Use -f2 because if rev-list is telling us this commit is
1048 # not worthwhile, we don't want to track its multiple heads,
1049 # just the history of its first-parent for others that will
1050 # be rebasing on top of it
1051 git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
1052 sha1=$(git rev-list -1 $rev)
1053 sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
1054 rm "$rewritten"/$rev
1055 fi
1056 done
34262322 1057
27c499bf 1058 complete_action
9f50d32b 1059}